(***************************************************)
(*    HTTcc Examples for the ICFP'13 submbission   *)
(*            Escaping from an infinit loop        *)
(***************************************************)

From mathcomp Require Import ssreflect ssrfun ssrbool ssrnat eqtype seq div.
From Kont Require Import rels prelude heaps domains hprop callcc srules.
Require Import Eqdep List.

Set Implicit Arguments.
Unset Strict Implicit.
Import Prenex Implicits.

Open Scope ccscope.

Parameter (X : lattice).

(* Simple Downward continuation examples: we use throw to escape 
   a (while True)-like loop when  x :-> w   *)

Definition escapeT (w: nat) j x : Type := 
  forall p: unit , SK X ( fun i => exists h, exists v: nat,
                                  i = x :-> v :+ h /\
                                  j = x :-> 0 :+ h , 
                        fun (y: unit) i m => False).                        


(* The function escapes the loop when x :-> w *)

Program
Definition escape w : SK X (xPredT, fun y i m =>  i = m /\ y = w)
                                :=
  Do ( x <-- alloc 0 ;
       c <-- callcc (fun i m => forall h (v: nat),
                                 i = x :-> v :+ h -> m = x :-> w :+ h)
                      (fun _ y i m => (CCC.ret_s tt).2 y i m)
                     (fun j exit => 
                       c <-- ffix (fun (f: escapeT w j x ) (y: unit) => 
                                           Do (
                                              p <-- @CCC.read X nat x ; 
                                              If  (w == p) Then 
                                                   (CCC.throw exit tt)
                                              Else
                                              (x ::= p .+1 ;;
                                              f y))) tt;
                       ret c);
       b <-- !x ;
       dealloc x ;;
       ret b).
Next Obligation.
move =>/= i [h][v][->]->.
apply: bnd_read; case: eqP=>/= H1; apply: vrfD=>D0; last first.
- by apply: bnd_write; apply: val_do=>//=; hhauto.
apply: val_throw=>//=.
split=>//; have D1: def (x :-> 0 :+ h) by rewrite !defPtUn in D0 *.
by move=>/=  h1 v1 ; case/( cancel D1)=>_ _ ->; rewrite H1.
Qed.
Next Obligation.
move =>/= i _;apply: bnd_alloc=>/= x; apply: bnd_ccc=>//.
+ by apply: bnd_bnd; apply: bnd_do=>//=; first by hhauto.
case=> j [k][_]; case; move/(_ i 0 (erefl _))=>->[_]-> {j k}. 
by apply: bnd_read; apply: bnd_dealloc; apply: val_ret.
Qed.
