(**************************************************)
(* HTTCC Examples from the  manuscript            *)
(*   LARGE-FOOTPRINT SEMANTICS VERSION            *)
(*  call make clean; make WH=1  first             *)  
(**************************************************)

From mathcomp Require Import ssreflect ssrfun ssrbool ssrnat eqtype seq. 
From Kont Require Import rels prelude heaps hprop callccWH srulesWH.
Require Import Eqdep.

Set Implicit Arguments.
Unset Strict Implicit.
Import Prenex Implicits.

Open Scope ccscope.

(* We will use this example to illustrate the semantic differences *)
(* between the old model and the new model i.e. the difference between *)
(* throwing and aborting by means of the following example. *)

Program 
Definition incr ( x : ptr) : 
  ST ( fun i => exists h, exists v: nat , 
                i= x :-> v :+ h , 
       fun y i m => forall h v, 
         i = x :-> v :+ h -> m = x :-> v .+1 :+ h /\ y = tt) := 
  Do ( z <-- ! x ; x ::= z .+1 ).
Next Obligation.     
move=> i [h][v]->; apply: bnd_read; apply: vrfD=>D; apply:val_write=> _ h1 v1.
by case/(cancel D)=>->_->; split=>//.
Qed.

Program
Definition swap T (x y : ptr) :
  ST ( fun i =>  exists h, exists v: T, exists w: T, 
                i= x :-> v :+ y :-> w :+ h , 
       fun _ i m => forall  h (v w : T), 
         i = x :-> v :+ y :-> w :+ h -> 
                   m = x :-> w :+ y :-> v :+h) := 
  Do ( p <-- @CCC.read T x ;  q <-- @CCC.read T y; x ::= q ;; y ::= p).
Next Obligation.
rewrite !gh; apply: ghE; first by move=> i [h][v][w]-> _; by exists (h,v,w).
move=> i [[h]]v w /= -> [h1][v1][w1] E; rewrite -unA=>D.
do 2 (apply: bnd_read; rewrite unCA); apply: bnd_write; rewrite unCA.
by apply val_write; rewrite unCA !unA=> _.
Qed.
Arguments swap{T}.

Section Throwswap.
Variables (x y : ptr) (V :nat).

Definition swapP1 j  : pre :=
     fun i => forall h (v w: nat), 
                 j = x :-> v :+ y :-> w :+ h -> 
                    i = x :-> v .+1 :+ y :-> w :+ h. 

Definition swapP2 j  : pre :=
     fun i => forall h (v w : nat), 
                 j = x :-> v :+ y :-> w :+ h -> 
                    i = x :-> v.+2  :+ y :-> w :+ h. 

Definition swapQ1: post unit := fun y i m => False.
Definition swapQ2 : post unit := 
  fun r i m => forall h (v w : nat), 
                 i = x :-> v :+ y :-> w :+ h -> 
                  m = x :-> w  :+ y :-> v :+ h.

Program
Definition throwswap : ST 
  ( fun i =>  exists h, i = x :-> V :+ y :-> V :+ h,
     fun r i m =>  forall h, i = x :-> V :+  y :-> V :+ h ->
                       m = x :-> V :+ y :-> V.+2 :+ h /\ r = tt) :=
  Do (c <-- @CCC.callcc (SigST unit)
(* sf *)
                (fun i => exists h,  
                              i = x :-> V :+ y :-> V  :+ h, 
                fun r i m => forall h (v w: nat),
                                i = x :-> v :+ y :-> w  :+ h ->
                                ( m = i /\ CCC.conseq (spec_of r) 
                             (swapP1 i) swapQ1)
                                \/ 
                                ( m = x :-> v.+1 :+ y :-> w :+ h  /\
                               CCC.conseq (spec_of r) (swapP2 i) swapQ2))

                   (fun j =>
                     (fun i =>
                       exists h, i = x :-> V :+ y :-> V :+ h /\ j = i
                       , fun z i m => 
                              m = i /\
                             CCC.conseq (spec_of z) 
                             (swapP1 j) swapQ1))
                                
        (fun j ex1 =>
           Do (ret (BigST (throw ex1 (BigST (@swap nat x y ;; ret tt)) _)))) _;
      incr x ;;
      comm c).
Next Obligation.
move=> i [h][->]J; apply: vrfD=> D; apply: val_ret; split=>//= k.
move/(_ h V V J)=>->; apply: val_throw=> h1 v1 w1; rewrite J.
rewrite -!unA in D *; move/(cancel D)=>[<-]D1; move/(cancel D1)=>[<-]_<-.
right; split=>// {k} k; move/(_ h V V); rewrite -unA; move/(_ (erefl _))=>->.
apply: val_do=>//=; first by hhauto.
move=>/= tt {k} k _ [tt1][k1][_] /= [H3][_]->.
move: (H3 h V.+2 V (erefl _))=>-> {h1 v1 w1 D1} h1 v1 w1; rewrite -!unA.
have D1: def (x :-> V.+2 :+ (y :-> V :+ h)) by rewrite !defPtUn in D *.
by case/(cancel D1)=><-D2; case/(cancel D2)=><-_<-.
Qed.
Next Obligation.
rewrite !gh; apply: ghE; first by  move=>i[_][h]-> _ ; exists (h,V,V).
move=> i p -> [->][h]E; rewrite E -!unA =>D. 
apply: val_do=>//=; first by  exists h; rewrite !unA.
move=> m k Dk [->] H2.
have P1: swapP1 (x :-> V :+ (y :-> V :+ h))
                    (x :-> V.+1 :+ (y :-> V :+ h)). 
 - by move=> h1 v1 w1; rewrite -!unA in D *; move/(cancel D)=>[<-]_<-.
have D1: def (x :-> V.+1 :+ ( y :-> V :+ h)) by rewrite  !defPtUn in D *.
left; case: (H2  (x :-> V.+1 :+ (y :-> V :+ h)) P1 D1)=>[H3 H4]; split=>//.
Qed.
Next Obligation.
move=> i [h]->; rewrite -unA; apply: vrfD=> D. 
apply: bnd_do=>// ; first by exists h; rewrite -unA.
move=>/= m k;rewrite !unA; case/(_ h V V (erefl _))=>[[->]H2|[->H2]].
(* First iteration*)
+ apply:bnd_do; first by exists (y :-> V :+ h); exists V; rewrite -unA.
 move=>/= tt {k} k; move/(_ (y :-> V:+ h) V); rewrite -unA.
 move/(_ (erefl _))=>[->]_.
 have P1: swapP1 (x :-> V :+ y :-> V :+ h)
                    (x :-> V.+1 :+ (y :-> V :+ h)). 
 - by move=> h1 v1 w1; rewrite -!unA in D *; move/(cancel D)=>[<-]_<-.
 have D1: def (x :-> V.+1 :+ (y :-> V :+ h)) by rewrite !defPtUn in D *.
 case: (H2 (x :-> V.+1  :+ ( y :-> V :+ h )) P1 D1)=>[H3 H4].
 apply:val_do=>//= {k tt} tt k Dk.
 by move/(H4 tt k); move/(_ Dk); apply: False_ind.
(*jumped back in *)
(* Last iteration *)
apply:bnd_do; first by exists ( y :-> V :+ h); exists V.+1; rewrite unA.
move=>/= tt{k} k; rewrite -unA; move/(_ (y :-> V :+ h)  V.+1 (erefl _))=>[->]_.
have P1: swapP2 (x :-> V :+ y :-> V :+ h) 
           (x :-> V.+2 :+ ( y :-> V :+ h)). 
- move=> h1 v1 w1;rewrite -!unA; move/(cancel D)=>[<-]D1. 
 by case/(cancel D1)=><-_->.
have D1: def (x :-> V.+2 :+ ( y :-> V :+ h)).
- by  rewrite !defPtUn in D *.
case: (H2 (x :-> V.+2 :+ ( y :-> V :+ h)) P1 D1)=>[H3 H4].
apply: val_do=>//= {k tt} [tt] k Dk P h1; rewrite -!unA.
move/(cancel D)=>[_]D2; move/(cancel D2)=>[_]_<-.
move:(H4 tt k P Dk); move/(_ h V.+2 V); rewrite !unA; move/(_ (erefl _))=>->.
by split=>//{P} ; case: tt.
Qed.
End Throwswap.

(* How to mimic abortswap using the old model : *)
(* For this particular example we can change abort f e for  x <- e; throw f ( *)

Section Abortswap.
Variables (x y : ptr) (V :nat).

Definition aswapP j  : pre :=
     fun i => forall h (v w: nat), 
                 j = x :-> v :+ y :-> w :+ h -> 
                    i = x :-> v .+1 :+ y :-> w :+ h. 


Definition aswapQ1: post unit := fun y i m => False.
Definition aswapQ2 : post unit := (CCC.ret_s tt).2.

Program
Definition abortswap : ST 
  ( fun i =>  exists h, i = x :-> V :+ y :-> V :+ h,
     fun r i m =>  forall h, i = x :-> V :+  y :-> V :+ h ->
                       m = x :-> V.+1 :+ y :-> V.+1 :+ h /\ r = tt) :=
  Do (c <-- @CCC.callcc (SigST unit)
(* sf *)
                (fun i => exists h,  
                              i = x :-> V :+ y :-> V  :+ h, 
                fun r i m => forall h (v w: nat),
                                i = x :-> v :+ y :-> w  :+ h ->
                                ( m = i  /\ 
                                  CCC.conseq (spec_of r) (aswapP i) aswapQ1)
                                \/ 
                                ( m = x :-> v :+ y :-> w.+1 :+ h  /\
                               CCC.conseq (spec_of r) (aswapP m ) aswapQ2))

                   (fun j =>
                     (fun i =>
                       exists h, i = x :-> V :+ y :-> V :+ h /\ j = i
                       , fun z i m => 
                              m = i /\
                             CCC.conseq (spec_of z) 
                             (aswapP j) aswapQ1))
                                
        (fun j ex1 =>
           Do (ret (BigST (@swap nat x y ;; throw ex1 (BigST (ret tt)) _)))) _;
      incr x ;;
      comm c).
Next Obligation.
move=> i[h][->] J; apply: vrfD=>D; apply: val_ret; split=>//= k.
move/(_ h V V J)=>->;apply: bnd_do; first (by hhauto). 
move=>/= _ {k}k; move/(_ h V.+1 V (erefl _))=>->.
apply: val_throw=>/= h1 v1 w1; rewrite J -!unA in D *.
by case/(cancel D)=><- D1; case/(cancel D1)=><- _ <-;right; split=>//.
Qed.
Next Obligation.
rewrite !gh; apply: ghE; first by move=>i [_] [h]-> _; exists (h,V,V). 
move=>i p ->[->][h]; rewrite -!unA=> H1 D1;case:(cancel D1 H1)=>-> D2.
case/(cancel D2)=>{D1 D2}-> _ ->; apply: val_do; first by rewrite !unA; hhauto.
by move=>/= c k _ [->]; left.
Qed.
Next Obligation.
move=>/= i [h]->; apply: vrfD=>D; apply: bnd_do=>/=; first by  hhauto.
move=>/= m k; move/(_ h V V (erefl _))=>H.
case: H; rewrite -!unA in D *; case=>-> H1.
+ apply: bnd_do; first by (exists (y :-> V :+ h); exists V; rewrite unA).
 case=>/= {k} k; move/(_ (y :-> V :+ h) V (erefl _))=>[->]_.
 have P1:  (aswapP (x :-> V :+ (y :-> V :+ h))) (x :-> V.+1 :+ (y :-> V :+ h)).
 - move=> h1 v1 w1;rewrite -!unA; case/(cancel D)=><- D1. 
  by case/(cancel D1)=><- _ <-.
 apply: vrfD; case/(H1 (x :-> V.+1 :+ (y :-> V :+ h)) P1)=>[P2 H2].
 by apply: val_do=>//=; case=> {k} k Dk; case/(H2 tt k)=>//.
apply: vrfD=>D1. 
have P1:  (aswapP (x :-> V :+ (y :-> V.+1 :+ h)))
  (x :-> V.+1 :+ (y :-> V .+1 :+ h)).
- move=> h1 v1 w1;rewrite -!unA; case/(cancel D1)=><- D2. 
 by case/(cancel D2)=><-_<-.
apply: bnd_do; first (by hhauto); case=>/= {k} k.
case/(_ (y :-> V.+1 :+ h) V (erefl _))=>-> _.
apply: vrfD; case/(H1 (x :-> V.+1 :+ (y :-> V.+1 :+ h)) P1).
move=>P2 H2; apply: val_do=>//= [[]]{k}k Dk; move/(H2 tt _);case/(_ Dk)=>_ ->.
by move=> h1; rewrite -!unA; case/(cancel D)=>_ D2; case/(cancel D2)=> _ _ <-.
Qed.
End Abortswap.
